script_name('ARZ Launcher Auto Fill')
script_author('chapo')
local fuelId, currentLiters, maxLiters = 0, 50, 100

addEventHandler('onReceivePacket', function(id, bs, ...)
    if (id == 220) then
        raknetBitStreamIgnoreBits(bs, 8)
        if (raknetBitStreamReadInt8(bs) == 17) then
            raknetBitStreamIgnoreBits(bs, 32)
            local str = raknetBitStreamReadString(bs, raknetBitStreamReadInt32(bs))
            if (str:find('window%.executeEvent%(\'(.+)%\', \'(.+)\'%)')) then
                local event, json = str:match('window%.executeEvent%(\'(.+)%\', \'(.+)\'%)')
                local json = decodeJson(json or '[]')
                if (event == 'event.gasstation.initializeFuelTypes') then 
                    for _, fuel in ipairs(json[1]) do
                        if (fuel.available == 1) then
                            fuelId = fuel.id
                        end
                    end
                elseif (event == 'event.gasstation.initializeMaxLiters') then 
                    maxLiters = tonumber(json[1]) or 100
                elseif (event == 'event.gasstation.initializeCurrentLiters') then 
                    currentLiters = tonumber(json[1]) or 50
                    purchaseFuel(fuelId, maxLiters - currentLiters)
                    sampAddChatMessage('AutoFill by chapo >> {ffffff} {623bff}'..(maxLiters - currentLiters)..' {ffffff}...', 0xFF623bff)
                end
            end
        end
    end
end)

function purchaseFuel(fuelIndex, fuelCount)
    local str = ('purchaseFuel|%s|%s'):format(fuelIndex, fuelCount)
    local bs = raknetNewBitStream()
    raknetBitStreamWriteInt8(bs, 220) -- packet id
    raknetBitStreamWriteInt8(bs, 18) -- packet type
    raknetBitStreamWriteInt8(bs, #str) -- str len
    raknetBitStreamWriteInt8(bs, 0)
    raknetBitStreamWriteInt8(bs, 0)
    raknetBitStreamWriteInt8(bs, 0)
    raknetBitStreamWriteString(bs, str)
    raknetBitStreamWriteInt32(bs, 0)
	raknetBitStreamWriteInt8(bs, 0)
	raknetBitStreamWriteInt8(bs, 0)
    raknetSendBitStreamEx(bs, 1, 7, 1)
    raknetDeleteBitStream(bs)
end